From: "Dr. Git" <drgitx@gmail.com>
Date: Tue, 4 Feb 2025 18:16:10 -0500
Subject: [PATCH] arm64: dts: qcom: sdm845-oneplus: camera bringup

---
 .../arm64/boot/dts/qcom/sdm845-oneplus-common.dtsi | 480 +++++++++++++++++++++
 .../boot/dts/qcom/sdm845-oneplus-enchilada.dts     |  14 +
 arch/arm64/boot/dts/qcom/sdm845-oneplus-fajita.dts |  28 ++
 3 files changed, 522 insertions(+)

diff --git a/arch/arm64/boot/dts/qcom/sdm845-oneplus-common.dtsi b/arch/arm64/boot/dts/qcom/sdm845-oneplus-common.dtsi
index 15c21db..d4cd590 100644
--- a/arch/arm64/boot/dts/qcom/sdm845-oneplus-common.dtsi
+++ b/arch/arm64/boot/dts/qcom/sdm845-oneplus-common.dtsi
@@ -7,8 +7,10 @@
 
 /dts-v1/;
 
+#include <dt-bindings/clock/qcom,camcc-sdm845.h>
 #include <dt-bindings/input/linux-event-codes.h>
 #include <dt-bindings/leds/common.h>
+#include <dt-bindings/media/video-interfaces.h>
 #include <dt-bindings/regulator/qcom,rpmh-regulator.h>
 #include <dt-bindings/sound/qcom,q6afe.h>
 #include <dt-bindings/sound/qcom,q6asm.h>
@@ -206,6 +208,103 @@ panel_vddi_poc_1p8: panel-vddi-poc-regulator {
 		enable-active-high;
 		regulator-boot-on;
 	};
+
+	main_cam_vdig: main-cam-vdig-regulator {
+		compatible = "regulator-fixed";
+		regulator-name = "main_cam_vdig";
+
+		regulator-min-microvolt = <1050000>;
+		regulator-max-microvolt = <1050000>;
+
+		gpio = <&tlmm 8 GPIO_ACTIVE_HIGH>;
+		enable-active-high;
+
+		vin-supply = <&vreg_s3a_1p35>;
+		vbias-supply = <&vreg_bob>;
+	};
+
+	main_cam_vana: main-cam-vana-regulator {
+		compatible = "regulator-fixed";
+		regulator-name = "main_cam_vana";
+
+		regulator-min-microvolt = <2800000>;
+		regulator-max-microvolt = <2800000>;
+
+		gpio = <&tlmm 27 GPIO_ACTIVE_HIGH>;
+		enable-active-high;
+
+		vin-supply = <&vreg_bob>;
+	};
+
+	front_cam_vdig: front-cam-vdig-regulator {
+		compatible = "regulator-fixed";
+		regulator-name = "front_cam_vdig";
+
+		regulator-min-microvolt = <1050000>;
+		regulator-max-microvolt = <1050000>;
+
+		gpio = <&tlmm 117 GPIO_ACTIVE_HIGH>;
+		enable-active-high;
+		regulator-boot-on;
+
+		vin-supply = <&vreg_s3a_1p35>;
+		vbias-supply = <&vreg_bob>;
+	};
+
+	front_cam_vana: front-cam-vana-regulator {
+		compatible = "regulator-fixed";
+		regulator-name = "front_cam_vana";
+
+		regulator-min-microvolt = <2800000>;
+		regulator-max-microvolt = <2800000>;
+
+		gpio = <&tlmm 104 GPIO_ACTIVE_HIGH>;
+		enable-active-high;
+		regulator-boot-on;
+
+		vin-supply = <&vreg_bob>;
+	};
+
+	sub_cam_vana: sub-cam-vana-regulator {
+		compatible = "regulator-fixed";
+		regulator-name = "sub_cam_vana";
+
+		regulator-min-microvolt = <1050000>;
+		regulator-max-microvolt = <1050000>;
+
+		gpio = <&tlmm 79 GPIO_ACTIVE_HIGH>;
+		enable-active-high;
+
+		vin-supply = <&vreg_s3a_1p35>;
+		vbias-supply = <&vreg_bob>;
+	};
+
+	sub_cam_vdig: sub-cam-vdig-regulator {
+		compatible = "regulator-fixed";
+		regulator-name = "sub_cam_vdig";
+
+		regulator-min-microvolt = <2800000>;
+		regulator-max-microvolt = <2800000>;
+
+		gpio = <&tlmm 78 GPIO_ACTIVE_HIGH>;
+		enable-active-high;
+
+		vin-supply = <&vreg_bob>;
+	};
+
+	sub_cam_vaf: sub-cam-vaf-supply {
+		compatible = "regulator-fixed";
+		regulator-name = "sub_cam_vaf";
+
+		regulator-min-microvolt = <2800000>;
+		regulator-max-microvolt = <2800000>;
+		regulator-enable-ramp-delay = <100>;
+
+		gpio = <&tlmm 77 GPIO_ACTIVE_HIGH>;
+		enable-active-high;
+
+		vin-supply = <&vreg_bob>;
+	};
 };
 
 &adsp_pas {
@@ -261,6 +360,9 @@ vreg_s7a_1p025: smps7 {
 			regulator-max-microvolt = <1028000>;
 		};
 
+		vdda_mipi_csi0_0p9:
+		vdda_mipi_csi1_0p9:
+		vdda_mipi_csi2_0p9:
 		vdda_mipi_dsi0_pll:
 		vdda_qlink_lv:
 		vdda_ufs1_core:
@@ -316,6 +418,18 @@ vreg_l20a_2p95: ldo20 {
 			regulator-initial-mode = <RPMH_REGULATOR_MODE_HPM>;
 		};
 
+		vreg_l21a_2p95: ldo21 {
+			regulator-min-microvolt = <2704000>;
+			regulator-max-microvolt = <2960000>;
+			regulator-initial-mode = <RPMH_REGULATOR_MODE_HPM>;
+		};
+
+		vreg_l22a_3p3: ldo22 {
+			regulator-min-microvolt = <2864000>;
+			regulator-max-microvolt = <3312000>;
+			regulator-initial-mode = <RPMH_REGULATOR_MODE_HPM>;
+		};		
+
 		vreg_l23a_3p3: ldo23 {
 			regulator-min-microvolt = <3300000>;
 			regulator-max-microvolt = <3312000>;
@@ -348,6 +462,13 @@ vreg_l28a_3p0: ldo28 {
 			regulator-max-microvolt = <3008000>;
 			regulator-initial-mode = <RPMH_REGULATOR_MODE_HPM>;
 		};
+
+		cam_vio_1p8:
+		vreg_lvs1_1p8: lvs1 {
+			regulator-min-microvolt = <1800000>;
+			regulator-max-microvolt = <1800000>;
+		};
+
 	};
 
 	regulators-1 {
@@ -380,6 +501,157 @@ vreg_s3c_0p6: smps3 {
 	};
 };
 
+&cci {
+	status = "okay";
+};
+
+&camss {
+	vdda-phy-supply = <&vreg_l1a_0p875>;
+	vdda-pll-supply = <&vreg_l26a_1p2>;
+
+	vdda-csi0-supply = <&vdda_mipi_csi0_0p9>;
+	vdda-csi1-supply = <&vdda_mipi_csi1_0p9>;
+	vdda-csi2-supply = <&vdda_mipi_csi2_0p9>;
+
+	status = "okay";
+
+	ports {
+		#address-cells = <1>;
+		#size-cells = <0>;
+		port@0 {
+			reg = <0>;
+			csiphy0_ep: endpoint {
+				bus-type = <MEDIA_BUS_TYPE_CSI2_CPHY>;
+				data-lanes = <0 1 2>;
+				remote-endpoint = <&imx519_ep>;
+			};
+		};
+
+		port@1 {
+			reg = <1>;
+			csiphy1_ep: endpoint {
+				bus-type = <MEDIA_BUS_TYPE_CSI2_DPHY>;
+				data-lanes = <0 1 2 3>;
+				remote-endpoint = <&imx376k_ep>;
+			};
+		};
+
+		port@2 {
+			reg = <2>;
+			csiphy2_ep: endpoint {
+				bus-type = <MEDIA_BUS_TYPE_CSI2_DPHY>;
+				data-lanes = <0 1 2 3>;
+				remote-endpoint = <&imx371_ep>;
+			};
+		};
+	};
+};
+
+&cci_i2c0 {
+	rear_cam: camera@1a {
+		compatible = "sony,imx519";
+		reg = <0x1a>;
+
+		reset-gpios = <&tlmm 28 GPIO_ACTIVE_HIGH>;
+		pinctrl-names = "default", "sleep";
+		pinctrl-0 = <&main_cam_default>;
+		pinctrl-1 = <&main_cam_sleep>;
+
+		clocks = <&clock_camcc CAM_CC_MCLK0_CLK>;
+		clock-names = "xclk";
+		clock-frequency = <24000000>;
+		assigned-clocks = <&clock_camcc CAM_CC_MCLK0_CLK>;
+		assigned-clock-rates = <24000000>;
+
+		power-domains = <&clock_camcc TITAN_TOP_GDSC>;
+
+		vana-supply = <&main_cam_vana>;
+		vcore-supply = <&main_cam_vdig>;
+		vio-supply = <&cam_vio_1p8>;
+
+		orientation = <1>; /* Rear camera */
+		rotation = <90>;
+
+		status = "okay";
+
+		port {
+			imx519_ep: endpoint {
+				remote-endpoint = <&csiphy0_ep>;
+				data-lanes = <1 2 3>;
+				link-frequencies = /bits/ 64 <500399375>;
+			};
+		};
+	};
+
+	front_cam: camera@10 {
+		compatible = "sony,imx371";
+		reg = <0x10>;
+
+		reset-gpios = <&tlmm 9 GPIO_ACTIVE_HIGH>;
+		pinctrl-names = "default", "sleep";
+		pinctrl-0 = <&front_cam_default>;
+		pinctrl-1 = <&front_cam_sleep>;
+
+		clocks = <&clock_camcc CAM_CC_MCLK1_CLK>;
+		clock-names = "xclk";
+		clock-frequency = <24000000>;
+
+		power-domains = <&clock_camcc TITAN_TOP_GDSC>;
+
+		vana-supply = <&front_cam_vana>;
+		vcore-supply = <&front_cam_vdig>;
+		vio-supply = <&cam_vio_1p8>;
+
+		orientation = <0>; /* Front camera */
+		rotation = <90>;
+
+		status = "okay";
+
+		port {
+			imx371_ep: endpoint {
+				remote-endpoint = <&csiphy2_ep>;
+				data-lanes = <1 2 3 4>;
+				link-frequencies = /bits/ 64 <654000000>;
+			};
+		};
+	};
+};
+
+&cci_i2c1 {
+	sub_cam: camera@10 {
+		compatible = "sony,imx376k";
+		reg = <0x10>;
+
+		reset-gpios = <&tlmm 23 GPIO_ACTIVE_HIGH>;
+		pinctrl-names = "default", "sleep";
+		pinctrl-0 = <&sub_cam_default>;
+		pinctrl-1 = <&sub_cam_sleep>;
+
+		clocks = <&clock_camcc CAM_CC_MCLK2_CLK>;
+		clock-names = "xclk";
+		clock-frequency = <24000000>;
+
+		power-domains = <&clock_camcc TITAN_TOP_GDSC>;
+
+		vana-supply = <&sub_cam_vana>;
+		vcore-supply = <&sub_cam_vdig>;
+		vio-supply = <&cam_vio_1p8>;
+
+		orientation = <1>; /* Rear camera */
+		rotation = <270>;
+
+		status = "okay";
+
+		port {
+			imx376k_ep: endpoint {
+				remote-endpoint = <&csiphy1_ep>;
+				data-lanes = <1 2 3 4>;
+				link-frequencies = /bits/ 64 <500000000>;
+			};
+		};
+	};
+};
+
 &cdsp_pas {
 	status = "okay";
 	firmware-name = "qcom/sdm845/oneplus6/cdsp.mbn";
@@ -897,6 +1169,214 @@ &usb_1_hsphy {
 &tlmm {
 	gpio-reserved-ranges = <0 4>, <81 4>;
 
+	main_cam_default: main-cam-default-state {
+		mclk0 {
+			pins = "gpio13";
+			function = "cam_mclk";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		rst {
+			pins = "gpio28";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		ois {
+			pins = "gpio40";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		ana {
+			pins = "gpio27";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		dig {
+			pins = "gpio8";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+	};
+
+	main_cam_sleep: main-cam-sleep-state {
+		mclk0 {
+			pins = "gpio13";
+			function = "cam_mclk";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+
+		rst {
+			pins = "gpio28";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		ois {
+			pins = "gpio40";
+			function = "gpio";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+
+		ana {
+			pins = "gpio27";
+			function = "gpio";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+
+		dig {
+			pins = "gpio8";
+			function = "gpio";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+	};
+
+	sub_cam_default: sub-cam-default-state {
+		mclk1 {
+			pins = "gpio15";
+			function = "cam_mclk";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		rst {
+			pins = "gpio23";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		vaf {
+			pins = "gpio77";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		ana {
+			pins = "gpio78";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		dig {
+			pins = "gpio79";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+	};
+
+	sub_cam_sleep: sub-cam-sleep-state {
+		mclk1 {
+			pins = "gpio15";
+			function = "cam_mclk";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+
+		rst {
+			pins = "gpio23";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		vaf {
+			pins = "gpio77";
+			function = "gpio";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+
+		ana {
+			pins = "gpio78";
+			function = "gpio";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+
+		dig {
+			pins = "gpio79";
+			function = "gpio";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+	};
+
+	front_cam_default: front-cam-default-state {
+		mclk2 {
+			pins = "gpio14";
+			function = "cam_mclk";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		rst {
+			pins = "gpio9";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		ana {
+			pins = "gpio104";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		dig {
+			pins = "gpio117";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+	};
+
+	front_cam_sleep: front-cam-sleep-state {
+		mclk2 {
+			pins = "gpio14";
+			function = "cam_mclk";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+
+		rst {
+			pins = "gpio9";
+			function = "gpio";
+			bias-disable;
+			drive-strength = <2>;
+		};
+
+		ana {
+			pins = "gpio104";
+			function = "gpio";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+
+		dig {
+			pins = "gpio117";
+			function = "gpio";
+			bias-pull-down;
+			drive-strength = <2>;
+		};
+	};
+
 	hall_sensor_default: hall-sensor-default-state {
 		pins = "gpio124";
 		function = "gpio";
diff --git a/arch/arm64/boot/dts/qcom/sdm845-oneplus-enchilada.dts b/arch/arm64/boot/dts/qcom/sdm845-oneplus-enchilada.dts
index 476f081..918765c 100644
--- a/arch/arm64/boot/dts/qcom/sdm845-oneplus-enchilada.dts
+++ b/arch/arm64/boot/dts/qcom/sdm845-oneplus-enchilada.dts
@@ -22,6 +22,20 @@ battery: battery {
 		voltage-min-design-microvolt = <3400000>;
 		voltage-max-design-microvolt = <4400000>;
 	};
+
+	main_cam_ois: main-cam-ois-regulator {
+		compatible = "regulator-fixed";
+		regulator-name = "main_cam_ois";
+
+		regulator-min-microvolt = <2864000>;
+		regulator-max-microvolt = <2864000>;
+		regulator-enable-ramp-delay = <100>;
+
+		gpio = <&tlmm 40 GPIO_ACTIVE_HIGH>; 
+		enable-active-high;
+
+		vin-supply = <&vreg_l22a_3p3>;
+	};
 };
 
 &display_panel {
diff --git a/arch/arm64/boot/dts/qcom/sdm845-oneplus-fajita.dts b/arch/arm64/boot/dts/qcom/sdm845-oneplus-fajita.dts
index 5a81287..2035fa5 100644
--- a/arch/arm64/boot/dts/qcom/sdm845-oneplus-fajita.dts
+++ b/arch/arm64/boot/dts/qcom/sdm845-oneplus-fajita.dts
@@ -21,6 +21,34 @@ battery: battery {
 		voltage-min-design-microvolt = <3400000>;
 		voltage-max-design-microvolt = <4400000>;
 	};
+
+	main_cam_ois: main-cam-ois-regulator {
+		compatible = "regulator-fixed";
+		regulator-name = "main_cam_ois";
+
+		regulator-min-microvolt = <2850000>;
+		regulator-max-microvolt = <2850000>;
+		regulator-enable-ramp-delay = <100>;
+
+		gpio = <&tlmm 40 GPIO_ACTIVE_HIGH>; 
+		enable-active-high;
+
+		vin-supply = <&vreg_l21a_2p95>;
+	};
+
+	main_cam_vaf: main-cam-vaf-regulator {
+		compatible = "regulator-fixed";
+		regulator-name = "main_cam_vaf";
+
+		regulator-min-microvolt = <2800000>;
+		regulator-max-microvolt = <2800000>;
+		regulator-enable-ramp-delay = <100>;
+
+		gpio = <&tlmm 31 GPIO_ACTIVE_HIGH>;
+		enable-active-high;
+
+		vin-supply = <&vreg_bob>;
+	};
 };
 
 &display_panel {
